from esc.cmds import Command

@Command(desc='Mattie\'s EventScripts variable parsing.\nusage: es <command string>\nThis will execute <command string> after parsing it for items like event_var() and server_var() and replacing them with the appropriate value.', pre=False, strs=0)
def _es(addonref, argv, userargs):
  if not argv:
    return 'es: Please provide a command string'
  addonref.genericcommand(argv, None, userargs)
  
  
@Command(desc='Mattie\'s EventScripts variable parsing, without quotation marks.\nusage: esnq <command string>\nThis will execute <command string> after parsing it for items like event_var() and server_var() and replacing them with the appropriate value. WARNING: Removes all quotation marks.', pre=False, strs=0)
def esnq(addonref, argv, userargs):
  if not argv:
    return 'esnq: Please provide a command string'
  addonref.genericcommand(argv, None, userargs)
  
@Command(desc='Remove quotation marks.\nusage: es_xnq <command string>\nThis will execute <command string> after removing quotation marks. WARNING: Removes all quotation marks.', pre=False, strs=0)
def es_xnq(addonref, argv, args, userargs):
  if not args:
    return 'es_xnq: Please provide a command string'
  if '"' in args:
    args = args.replace('"', '')
  for args in parse.splitcommands(args):
    argv = parse.tokenize(args)
    addonref.genericcommand(argv, args, userargs)
