import es, keyvalues
from esc import parse, interface
from esc.cmds import Command

@Command(con=True, desc='Creates a keygroup that can be loaded and saved to a file. Must call es_keygroupdelete to free this memory!')
def keygroupcreate(addonref, argv):
  pass

@Command(con=True, desc='Deletes a keygroup from memory so that it\'s not leaked.')
def keygroupdelete(addonref, argv):
  pass

@Command(con=True, desc='Renames an existing keygroup.')
def keygrouprename(addonref, argv):
  pass
  
@Command(con=True, desc='Lists all key values in memory that aren\'t groups. Optionally can look up a group, if you provide one.')
def keylist(addonref, argv):
  pass

@Command(con=True, desc='Copies a keygroup.')
def keygroupcopy(addonref, argv):
  pass

@Command(con=True, desc='Loads a keygroup from file based on its name.')
def keygroupload(addonref, argv):
  pass

@Command(con=True, desc='Saves a keygroup to a file based on its name.')
def keygroupsave(addonref, argv):
  pass

@Command(con=True, desc='Creates a key that can be free-floating or associated with a group. Must call es_keydelete to free this memory when you\'re done.')
def keycreate(addonref, argv):
  pass

@Command(con=True, desc='Deletes a key from memory so that it\'s not leaked when you\'re done with it.')
def keydelete(addonref, argv):
  pass

@Command(con=True, desc='Deletes keys from a keygroup that match or don\'t match a certain value.')
def keygroupfilter(addonref, argv):
  pass

@Command(con=True, desc='Rename a key.')
def keyrename(addonref, argv):
  pass

@Command(con=True, desc='Sets a value within a given key (where the key could be free-floating or associated with a group).')
def keysetvalue(addonref, argv):
  pass

@Command(con=True, desc='Gets a value within a given key (where the key could be free-floating or associated with a group).')
def keygetvalue(addonref, argv):
  pass
  
@Command(con=True, desc='EXPERIMENTAL. Loops through a keygroup and performs a single command on each key, providing a single variable with the key name.')
def foreachval(addonref, argv):
  pass

@Command(desc='EXPERIMENTAL. Loops through a keygroup and performs a single command on each key, providing a single variable with the key name.')
def foreachkey(addonref, argv, userargs=None):
  if len(argv) < 4 or argv[1] != 'in':
    return 'Syntax: es_foreachkey <var> in <groupname> <command>'
  keygroup = str(argv[2])
  if not es.exists('keygroup', keygroup):
    return 'ERROR: Eventscripts cannot find keygroup: %s!' % argv[2]
  var = argv[0]
  args = parse.argsfrom(argv[3], 1)
  argv = parse.tokenize(argv[3])
  for key in keyvalues.getKeyGroup(keygroup).keys():
    interface.setvar(var, key)
    addonref.genericcommand(list(argv), args, userargs)
