import es, gamethread
from esc import interface, parse
from esc.cmds import Command

@Command(desc='Just runs a command-string inside of the variable.')
def commandv(addonref, argv, userargs=None):
  if not argv:
    return 'Syntax: es_commandv <variable>'
  if not es.exists('variable', argv[0]):
    return 'ERROR: Variable does not exist'
  args = interface.server_var(argv[0])
  addonref.genericcommand(parse.tokenize(args), args, userargs)

@Command(desc='Will run <commandstring>, after <seconds> seconds.', argsfrom=2)
def delayed(addonref, argv, args, userargs=None):
  if len(argv) < 2 or type(argv[0]) is str:
    return 'Syntax: es_delayed <seconds> <commandstring>'
  gamethread.delayed(float(argv[0]), addonref.genericcommand, (argv[1:], args, userargs))

@Command(desc='Adds a command to the end of the command queue.', argsfrom=1)
def soon(addonref, argv, args, userargs=None):
  gamethread.delayed(0, addonref.genericcommand, (argv[1:], args, userargs))
